<?php
/* $Id: _message.form.php,v 1.6 2006/10/24 09:21:48 kx Exp $ */

/*
  / 
*/
function show_msg_form($message, $form_action, $topic_type = 'reply') {
	global $current_user, $Forum_Data, $Forum_Design;

	$mess = array();

	$subject = ( trim($message['Topic_subject']) == '' ) ? "" : $message['Topic_subject'];

	$mess['forum_i_topic_id'] = ( $message['Topic_ID'] == '' ) ? $Forum_Data[Topic_ID] : $message['Topic_ID'];
	$mess['forum_i_subdiv_id'] = $message['Subdiv_ID'];
	$mess['forum_parent_topic_id'] = $message['Parent_topic_ID'];
	$mess['form_action'] = $form_action;
	$mess['Theme_type'] = '';

	$lang = array(
		'Username' => NETCAT_MODULE_FORUM_USERNAME,
		'Topic_type' => NETCAT_MODULE_FORUM_TOPIC_TYPE,
		'New_message' => NETCAT_MODULE_FORUM_NEW_MESSAGE,
		'Subject' => NETCAT_MODULE_FORUM_TOPIC_SUBJECT,
		'Font_size' => NETCAT_MODULE_FORUM_FONTSIZE,
		'Font_color' => NETCAT_MODULE_FORUM_FONTCOLOR,
		'Default' => NETCAT_MODULE_FORUM_COLOR0,
		'Blue' => NETCAT_MODULE_FORUM_COLOR000066,
		'Green' => NETCAT_MODULE_FORUM_COLOR006600,
		'Red' => NETCAT_MODULE_FORUM_COLOR660000,
		'White' => NETCAT_MODULE_FORUM_COLORFFFFFF,
		'Black' => NETCAT_MODULE_FORUM_COLOR000000,
		'Quote' => NETCAT_MODULE_FORUM_FSQUOTE,
		'Italic' => NETCAT_MODULE_FORUM_FSITALIC,
		'Code' => NETCAT_MODULE_FORUM_FSCODE,
		'List' => NETCAT_MODULE_FORUM_FSLIST,
		'Image' => NETCAT_MODULE_FORUM_FSIMG,
		'URL' => NETCAT_MODULE_FORUM_FSURL,
		'Preview' => NETCAT_MODULE_FORUM_PREVIEW,
		'Send_message' => NETCAT_MODULE_FORUM_SEND,
		'Bold' => NETCAT_MODULE_FORUM_FSBOLD,
		'Italic' => NETCAT_MODULE_FORUM_FSIALIC,
		'Underlined' => NETCAT_MODULE_FORUM_FSUNDERLINE,
		'Topic_type' => NETCAT_MODULE_FORUM_TOPIC_TYPE,
		'Topic_type_common' => NETCAT_MODULE_FORUM_TOPIC_TYPE_TRIVIAL,
		'Topic_type_sticky' => NETCAT_MODULE_FORUM_TOPIC_TYPE_STICKY,
		'Topic_type_announce' => NETCAT_MODULE_FORUM_TOPIC_TYPE_ANNOUNCE,
		'Topic_type_closed' => NETCAT_MODULE_FORUM_TOPIC_TYPE_CLOSED,
		'H_HELP' => NETCAT_MODULE_FORUM_H_HELP,
		'B_HELP' => NETCAT_MODULE_FORUM_B_HELP,
		'I_HELP' => NETCAT_MODULE_FORUM_I_HELP,
		'U_HELP' => NETCAT_MODULE_FORUM_U_HELP,
		'Q_HELP' => NETCAT_MODULE_FORUM_Q_HELP,
		'C_HELP' => NETCAT_MODULE_FORUM_C_HELP,
		'L_HELP' => NETCAT_MODULE_FORUM_L_HELP,
		'P_HELP' => NETCAT_MODULE_FORUM_P_HELP,
		'W_HELP' => NETCAT_MODULE_FORUM_W_HELP,
		'S_HELP' => NETCAT_MODULE_FORUM_S_HELP,
		'F_HELP' => NETCAT_MODULE_FORUM_F_HELP,
		'Error_subject_message' => NETCAT_MODULE_FORUM_EMPTY_SUBJECT_MESSAGE,
		'Error_message' => NETCAT_MODULE_FORUM_EMPTY_MESSAGE
	);

	$mess = array_merge($mess, $lang);

        $hidden_url = ( isset($_POST['hidden_url']) ) ? $_POST['hidden_url'] : ( (isset($_SERVER['REQUEST_URI']) ) ? $_SERVER['REQUEST_URI'] : false);

        if ( strpos($hidden_url, '?') ) {
           $hidden_url = substr_replace($hidden_url, '', strpos($hidden_url, '?'));
        }

	$mess['hidden_url'] = $hidden_url;

	if ( $topic_type == 'topic' ) {
		$ttype = array();
		$r1 = ( $Forum_Data['perm']['sticky'] > 0 ) ? "" : "readonly";
		$r2 = ( $Forum_Data['perm']['announce'] > 0 ) ? "" : "readonly";

		$s = array();
		$s[round($message['Topic_type'])] = 'checked';

		$ttype['rb_sticky'] = "<input type=radio value=1 " . $r1 . " name='forum_i_topic_type'  ${s[1]} />";
		$ttype['rb_common'] = "<input type=radio value=0 name='forum_i_topic_type' ${s[0]} />";
		$ttype['rb_announce'] = "<input type=radio value=2 " . $r2 . " name='forum_i_topic_type'  ${s[2]} />";
		$ttype['rb_announce'] .= '<input type="hidden" name="ttype" value="topic" />';
		$ttype = array_merge($ttype, $lang);

		$ttype['rb_closed'] = ( ($Forum_Data['perm']['edit'] > 1) ) ? "<input type=checkbox name='forum_i_topic_closed' value='1' " . ( $message['Topic_closed'] == 1 ? "checked" : "" ) . " />" : "";
		$ttype['Topic_type_closed'] = ( ($Forum_Data['perm']['edit'] > 1) ) ? $lang['Topic_type_closed'] : '';
		$mess['Theme_type'] = forum_vis_template($Forum_Design['Theme_type'], $ttype);

	}

	$mess['forum_i_message'] = $message['Topic_message'];
	$mess['forum_i_creator_name'] = $message['Topic_creator_name'];
	$mess['forum_i_subject'] = $subject;

	$mess['USERNAME'] = ( $current_user['User_ID'] ? '' : forum_vis_template($Forum_Design['User_name'], $mess) );
	$mess['MESSAGE'] = $message['MESSAGE'];

	if ( $message['BBMESSAGE'] ) {
		$mess['Source_message'] = get_source_message_box($message['BBMESSAGE']);
	}

	// Don't show CAPTCHA blocks if user is registered and logged in
	if ($GLOBALS["AUTH_USER_ID"])
	{
	   $Forum_Design['Message_table'] = preg_replace("/\<\!--\s*%Captcha_block_begins%\s*--\>.+?\<\!--\s*%Captcha_block_ends%\s*--\>/is", "", $Forum_Design['Message_table']);
	}
	// show CAPTCHA unless user is logged in
	elseif ($GLOBALS["MODULE_VARS"]["captcha"] && function_exists('imagegif'))
	{
           $mess['Captcha_image'] = nc_captcha_formfield();
           $mess['Captcha_message'] = NETCAT_MODERATION_CAPTCHA;
           $mess['Captcha_field'] = "<input type=text name=nc_captcha_code size=10>";
	}


	$text = forum_vis_template($Forum_Design['Message_table'], $mess);


	return $text;
}





?>