<?

require_once("../../../vars.inc.php");
require_once("../../../admin/function.inc.php");
require_once($INCLUDE_FOLDER."s_loadenv.inc.php");
require_once($INCLUDE_FOLDER."s_e404.inc.php");

LoadModuleEnv();

class Netshop_ExportYML extends Netshop
{
   function Netshop_ExportYML()
   {
      $this->Netshop();
   }

   /**
        *    YandexML
        * @param int ,    (  -  )
        */
   function ExportYML($section=0)
   {
      if (!$this->shop_id) return false;

      $currency_id = $this->Currencies[$this->DefaultCurrencyID];

      header ("Content-type: text/xml");
      $ret = "<?xml version=\"1.0\" encoding=\"windows-1251\"?>
                 <!DOCTYPE yml_catalog SYSTEM \"shops.dtd\">
                 <yml_catalog date=\"".(strftime("%Y-%m-%d %H:%M"))."\">
                 <shop>
                  <name>".xmlspecialchars($this->ShopName)."</name>
                  <company>".xmlspecialchars($this->CompanyName)."</company>
                  <url>http://$_SERVER[HTTP_HOST]/</url>
                  <currencies>
                    <currency id=\"RUR\" rate=\"1\" />";

      if ($currency_id != "RUR")
      {
         $ret .= "<currency id=\"$currency_id\" rate=\"".
         ($this->Rates[$this->DefaultCurrencyID]+(100+$this->CurrencyConversionPercent)/100)
         ."\" />";
      }

      $ret .= "</currencies>
                <categories>\n";

      // output categories (shop structure) ---------------------------
      if (!$section) $section = $this->shop_id;
      $structure = GetStructure($section, "Checked=1");

      $all_sections_ids = array(); //       

      foreach ($structure as $row)
      {
         $ret .= "<category id=\"$row[Subdivision_ID]\"".
         ($row["Parent_Sub_ID"]==$section ? "":" parentID=\"$row[Parent_Sub_ID]\"").
         ">".xmlspecialchars($row["Subdivision_Name"])."</category>\n";

         $all_sections_id[] = $row["Subdivision_ID"];
      }

      $ret .= "</categories>\n<offers>";

      // GOODS CATALOGUE -----------------------------------------------
      $output = array("Name"=>"name",
      "Vendor"=>"vendor",
      "Description"=>"description",
      "URL"=>"url",
      "Price"=>"price",
      "Image"=>"picture");

      //   
      $goods_class_ids = $this->GuessGoodsTypeIDs();

      //   
      $subdivision_id = join(",", $all_sections_id);

      foreach ($goods_class_ids as $class_id)
      {
         $res = q("SELECT m.*,
                          CONCAT(u.Hidden_URL, s.EnglishName, '_', m.Message_ID, '.html') as URL,
                          IFNULL(m.$this->PriceColumn, parent.$this->PriceColumn) as Price4User,
                          IF(m.$this->PriceColumn IS NULL, parent.$this->CurrencyColumn, m.$this->CurrencyColumn) as Currency4User

                    FROM (Message$class_id as m, Subdivision as u, Sub_Class as s)
                         LEFT JOIN Message$class_id as parent
                                ON (m.Parent_Message_ID != 0 AND m.Parent_Message_ID=parent.Message_ID)
                    WHERE m.Checked=1
                      AND m.Subdivision_ID IN ($subdivision_id)
                      AND s.Subdivision_ID = m.Subdivision_ID
                      AND s.Class_ID = $class_id
                      AND u.Subdivision_ID = m.Subdivision_ID
                    HAVING Price4User > 0
                    ");

         while ($row=mysql_fetch_assoc($res))
         {
            // convert to default currency
            $row["Price"] = $this->ConvertCurrency($row["Price4User"], $row["Currency4User"]);
            // we'll need an absolute url
            $row["URL"] = "http://$_SERVER[HTTP_HOST]$row[URL]";

            if ($row["Image"]) // replace to image url
            {
               $row["Image"] = "http://$_SERVER[HTTP_HOST]" . nc_file_path($class_id, $row["Message_ID"], "Image", "h_");
   //            preg_match("/[^.]+\.([^.:]+):.+/", $row["Image"], $regs);
   //            $row["Image"] = "http://$_SERVER[HTTP_HOST]/netcat_files/$row[Image_Field_ID]_$row[Message_ID].$regs[1]";
            }

            $ret .= "<offer>\n<currencyId>$currency_id</currencyId>\n";

            foreach ($output as $idx=>$tag)
            {
               if ($row[$idx]) $ret .= "<$tag>".xmlspecialchars($row[$idx])."</$tag>\n";
            }

            if (strlen($row["StockUnits"]))
            {
               $ret .=  "<orderingTime><ordering>".
               ($row["StockUnits"] ? " " : " " ).
               "</ordering></orderingTime>\n";
            }

            $ret .= "</offer>\n";
         }
      }
      // ---------------------------------------------------------------

      $ret .= "</offers>\n</shop>\n</yml_catalog>";
      print $ret;
      //      return $ret;
   }
}


//---------------

$catalogue = GetCatalogueID($HTTP_HOST);
if (!$catalogue) $catalogue = 1;


$shop = new NetShop_ExportYML();
$shop->ExportYML();

?>
