<?php
/* $Id: function.inc.php,v 1.7 2006/10/23 11:54:04 kx Exp $ */

##############################################
#        
##############################################
function InsertFieldsFromBaseClass($BaseClassID,$NewClassID){
	global $db;

    $db->query("INSERT INTO Field (Class_ID, Field_Name, Description, TypeOfData_ID, Format, NotNull, Priority, DoSearch, DefaultState, Inheritance, System_Table_ID, TypeOfEdit_ID) SELECT $NewClassID, Field_Name, Description, TypeOfData_ID, Format, NotNull, Priority, DoSearch, DefaultState, Inheritance, System_Table_ID, TypeOfEdit_ID FROM Field WHERE Class_ID=$BaseClassID");

    if ($Result = $db->get_results("SELECT Field_ID FROM Field WHERE Class_ID='$NewClassID'"))
    {
    	foreach( $Result as $Array )
    	{
    		ColumnInMessage($Array->Field_ID,1,$db);
    	}
    }
}

##############################################
#         
##############################################
function InsertActionsFromBaseClass($BaseClassID,$NewClassID){
	global $db;

	$ret=false;
	if ($Result = $db->get_results("SELECT AddTemplate, EditTemplate, AddActionTemplate, EditActionTemplate, SearchTemplate, FullSearchTemplate, SubscribeTemplate, AddCond, EditCond, SubscribeCond, CheckActionTemplate, DeleteActionTemplate FROM Class WHERE Class_ID='$BaseClassID'", ARRAY_A))
	{
		foreach( $Result as $Array )
		{
			foreach ( $Array as $key => $val )
			{
				if($val!="") {
    				$q.=$key."=\"".addslashes($val)."\" ,";
    				$ret=true;
				}
			}
		}
	}

    $q=substr($q,0,strlen($q)-1);
    if ($ret)
    	$db->query("UPDATE Class SET ".$q. " where Class_ID='$NewClassID';");
}

##############################################
#    
##############################################
function ClassGroupList()
{
	global $db;

	if ( $Result = $db->get_results("SELECT DISTINCT Class_Group FROM Class WHERE System_Table_ID=0 ORDER BY Class_Group ASC") )
	{
		?>
 		<form method=post action=index.php>
		<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td bgcolor=cccccc>

		<table border=0 cellpadding=4 cellspacing=1 width=100%>
		<tr>
		<td bgcolor=eeeeee><font size=-2><b><?=CONTROL_CLASS_CLASS_GROUPS?></b></td>
		</tr>
		<?

		foreach( $Result as $Array )
		{
			print "<tr>";
			print "<td bgcolor=white><a href=\"index.php?phase=1&ClassGroup=".urlencode($Array->Class_Group)."\">".$Array->Class_Group."</a></td>";
			print "</tr>";
		}
		?>
		</table>
		</td></tr></table><br>
		<?
	}
	else
	{
		echo CONTROL_CLASS_NONE;
	}
	?>
	<a href=index.php?phase=10><b><?=CONTROL_CLASS_ADD?></a>
	<?
}


##############################################
#   
##############################################
function ClassList($Class_Group=false)
{
	global $db;

	if ($Class_Group)
	{
		$select = "SELECT Class_ID, Class_Name, IF(AddTemplate<>'' OR AddCond<>'' OR AddActionTemplate<>'',1,0) AS IsAdd, IF(EditTemplate<>'' OR EditCond<>'' OR EditActionTemplate<>'' OR CheckActionTemplate<>'' OR DeleteActionTemplate<>'',1,0) AS IsEdit, IF(SearchTemplate<>'' OR FullSearchTemplate<>'',1,0) AS IsSearch, IF(SubscribeTemplate<>'' OR SubscribeCond<>'',1,0) AS IsSubscribe from Class where Class_Group='".urldecode($Class_Group)."' AND System_Table_ID=0 order by Class_ID";
	}
	else
	{
		$select = "SELECT Class_ID, Class_Name, IF(AddTemplate<>'' OR AddCond<>'' OR AddActionTemplate<>'',1,0) AS IsAdd, IF(EditTemplate<>'' OR EditCond<>'' OR EditActionTemplate<>'' OR CheckActionTemplate<>'' OR DeleteActionTemplate<>'',1,0) AS IsEdit, IF(SearchTemplate<>'' OR FullSearchTemplate<>'',1,0) AS IsSearch, IF(SubscribeTemplate<>'' OR SubscribeCond<>'',1,0) AS IsSubscribe, Class_Group from Class where System_Table_ID=0 order by Class_ID";
	}

	if ( $Result = $db->get_results($select) )
	{
		?>
		<form method=post action=index.php>
 		<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td bgcolor=cccccc>

 		<table border=0 cellpadding=4 cellspacing=1 width=100%>
 		<tr>
 		<td bgcolor=eeeeee><font size=-2><b>ID</td>
 		<td bgcolor=eeeeee width=45%><font size=-2><b><?=CONTROL_CLASS_CLASS?></b></td>
 		<? if(!$Class_Group) echo("<td bgcolor=eeeeee width=45%><font size=-2><b>".CONTROL_USER_GROUP."</b></td>"); ?>
 		<td bgcolor=eeeeee align=center><font size=-2><b><?=CONTROL_CLASS_ACTIONS?></b></td>
 		<td bgcolor=eeeeee align=center><font size=-2><b><?=CONTROL_CLASS_FIELDS?></b></td>

 		<td bgcolor=eeeeee align=center><img src=../images/kill.gif width=18 height=18 alt='<?=CONTROL_CLASS_DELETE?>'></td>
 		</tr>
 		<?
 		foreach( $Result as $Array )
		{
			print "<tr>";
			print "<td bgcolor=white><font size=-2><b>".$Array->Class_ID."</td>";
			print "<td bgcolor=white><a href=\"index.php?phase=4&ClassID=".$Array->Class_ID.($Class_Group?'&ClassGroup='.urlencode($Class_Group):'')."\">".$Array->Class_Name."</a></td>";
			if(!$Class_Group) print "<td width='1%' bgcolor=white><font size=-2><a href=\"index.php?phase=1&ClassGroup=".urlencode($Array->Class_Group)."\">".$Array->Class_Group."</a></td>";
			print "<td bgcolor=white align=center><font size=-2><a href=\"index.php?phase=8&ClassID=".$Array->Class_ID."&myaction=1".($Class_Group?'&ClassGroup='.urlencode($Class_Group):'')."\">".(!$Array->IsAdd?"<font color=gray>":"")."".CONTROL_CLASS_ACTIONS_ADD."</a>&nbsp;&nbsp;<a href=\"index.php?phase=8&ClassID=".$Array->Class_ID."&myaction=2".($Class_Group?'&ClassGroup='.urlencode($Class_Group):'')."\">".(!$Array->IsEdit?"<font color=gray>":"")."".CONTROL_CLASS_ACTIONS_EDIT."</a>&nbsp;&nbsp;<a href=\"index.php?phase=8&ClassID=".$Array->Class_ID."&myaction=3".($Class_Group?'&ClassGroup='.urlencode($Class_Group):'')."\">".(!$Array->IsSearch?"<font color=gray>":"")."".CONTROL_CLASS_ACTIONS_SEARCH."</a>&nbsp;&nbsp;<a href=\"index.php?phase=8&ClassID=".$Array->Class_ID."&myaction=4".($Class_Group?'&ClassGroup='.urlencode($Class_Group):'')."\">".(!$Array->IsSubscribe?"<font color=gray>":"")."".CONTROL_CLASS_ACTIONS_MAIL."</a></td>";
			print "<td bgcolor=white align=center><font size=-2><a href=\"/netcat/admin/field/?ClassID=".$Array->Class_ID."\"><img border=0 width=16 height=16 alt='".CONTROL_CLASS_FIELDSLIST."' src=../images/list.gif></a></td>";
			print "<td bgcolor=white align=center><INPUT TYPE=CHECKBOX NAME=\"Delete".$Array->Class_ID."\" VALUE=".$Array->Class_ID."></td>";
			print "</tr>";
		}
		?>
		</table>
		</td></tr></table><br>
		<?
	}
	else
	{
		echo CONTROL_CLASS_NONE;
	}

	?>
	<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td><a href=index.php?phase=10><b><?=CONTROL_CLASS_ADD?></a></td>
	<?
	if ($Array)
	{
		?>
		<td align=right><input class=s type=reset value='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_CANCEL?>'> <input type=submit class=s value='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE?>'></td>
		<?
	}
	?>
	</tr></table>
	<?
	if ($Array)
	{
		?>
 		<input type=hidden name=phase VALUE=6>
 		</form>
 		<?
 	}
}

##############################################
#  / 
##############################################
function ClassForm ($ClassID, $action, $phase, $type, $BaseClassID )
{
	# type = 1 -  insert
	# type = 2 -  update
	# type = 3 -  update  System_Table,
	#  type = 3 ClassID   SystemTableID
	global $db, $ROOT_FOLDER, $ClassGroup;

	$select = "SELECT Class_Name, DaysToHold, AllowTags, NL2BR, ";
	$select .= "FormPrefix, FormSuffix, RecordTemplate, RecordsPerPage,";
	$select .= "SortBy, RecordTemplateFull, TitleTemplate, Settings, Class_Group, UseCaptcha";
	$select .= " FROM Class WHERE ";

	if($BaseClassID)
	{
		$type=2;
		$ClassID=$BaseClassID;
	}
	?>
	<font color=gray><?=CONTROL_CLASS_INFO_ADDSLASHES?></font>
	<form method=post action=<?= $action ?>>

 	<?
	if ($type == 1)
	{
		if (!$Array->Class_Name)
			$Array->Class_Name = CONTROL_CLASS_NEWCLASS;
		if (!$Array->FormPrefix)
			$Array->FormPrefix = "\$f_AdminCommon";
		if (!$Array->RecordTemplate)
			$Array->RecordTemplate = "\$f_AdminButtons";
		if (!$Array->RecordsPerPage)
			$Array->RecordsPerPage = "20";
	}
	elseif ($type == 2)
	{
		$select .= " Class_ID=".$ClassID;
		$Array = $db->get_row($select) ;

		if (!$Array)
			print "<BR>".CONTROL_CLASS_ERRORS_DB."<BR>\n";
	}
	elseif ($type == 3)
	{
		$select .= " System_Table_ID=".$ClassID;
		$Array = $db->get_row($select);
		if (!$Array)
			print "<BR>".CONTROL_CLASS_ERRORS_DB."<BR>\n";
	}

	if ( ($type == 1) or ($type == 2) )
	{
    	print "<font color=gray>".CONTROL_CLASS_CLASS_NAME.":<br><INPUT TYPE=TEXT NAME=ClassName SIZE=50 VALUE='".htmlspecialchars($Array->Class_Name)."'><br><br>";
	}

	if ($type==1 or $type==2)
	{
		print(CONTROL_USER_GROUP.":<br><select name='Class_Group' style='width: auto;'>\n");

		foreach ( $db->get_col("SELECT DISTINCT Class_Group FROM Class") as $Class_Group)
		{
			if ($Array->Class_Group==$Class_Group)
				echo("\t<option value='".$Class_Group."' selected='selected'>".$Class_Group."</option>\n");
 			else
 				echo("\t<option value='".$Class_Group."'>".$Class_Group."</option>\n");
		}

		unset($grs);
		print("</select>&nbsp;&nbsp;&nbsp;".CONTROL_CLASS_NEWGROUP.":&nbsp;<INPUT TYPE=TEXT NAME=Class_Group_New SIZE=8 MAXLENGTH=64><br><br>");
	}

	if (($type==2 || $type==3) && !$BaseClassID)
		echo "<a href=/netcat/admin/field/".($type!=3?"?ClassID=".$ClassID:"systemField.php?SystemTableID=".$ClassID)."><b>".CONTROL_CLASS_CLASS_GOTOFIELDS."</b></a><br><br>";

	?>
	<b><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST?></font></b>
	<table border=0 cellpadding=6 cellspacing=0 width=100% bgcolor=#F3F3F3>
	<tr><td><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_PREFIX?>:<br><TEXTAREA WRAP=OFF ROWS=10 COLS=60 NAME=FormPrefix><?=htmlspecialchars($Array->FormPrefix)?></TEXTAREA></td></tr>
	<TR><TD><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_BODY?>:<br><TEXTAREA WRAP=OFF ROWS=10 COLS=60 NAME=RecordTemplate><?=htmlspecialchars($Array->RecordTemplate)?></TEXTAREA></TD></TR>
	<TR><TD><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SUFFIX?>:<br><TEXTAREA WRAP=OFF ROWS=10 COLS=60 NAME=FormSuffix><?=htmlspecialchars($Array->FormSuffix)?></TEXTAREA></TD></TR>
	<tr><td><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOW?> <INPUT TYPE=TEXT NAME=RecordsPerPage SIZE=4 MAXLENGTH=255 VALUE='<?=htmlspecialchars($Array->RecordsPerPage)?>'> <?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ?></td></tr>
	<tr><td><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SORT?>*:<br><INPUT TYPE=TEXT NAME=SortBy SIZE=50 MAXLENGTH=255 VALUE='<?=htmlspecialchars($Array->SortBy)?>'><br>
	* <?=CONTROL_CLASS_CLASS_OBJECTSLIST_SORTNOTE?></td></tr>
	</table><br>

	<b><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTVIEW?></font></b>
	<table border=0 cellpadding=6 cellspacing=0 width=100% bgcolor=#F3F3F3>
	<tr><td><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_PAGETITLE?>:<br><INPUT TYPE=TEXT NAME=TitleTemplate SIZE=50 MAXLENGTH=255 VALUE='<?=htmlspecialchars($Array->TitleTemplate)?>'></td></tr>
	<tr><td><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_PAGEBODY?>:<br><TEXTAREA WRAP=OFF ROWS=10 COLS=60 NAME=RecordTemplateFull><?=htmlspecialchars($Array->RecordTemplateFull)?></TEXTAREA></td></tr>
	</table><br>

	<b><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_DOPL?></font></b>
	<table border=0 cellpadding=6 cellspacing=0 width=100% bgcolor=#F3F3F3>
	<?
	print "<tr><td colspan=2><font color=gray><input type=checkbox id=tags name=AllowTags ".($Array->AllowTags?"checked":"")." value=1> <label for=tags>".CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_HTML."</label></td></tr>";
	print "<tr><td colspan=2><font color=gray><input type=checkbox id=br name=NL2BR ".($Array->NL2BR?"checked":"")." value=1> <label for=br>".CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_BR."</label></td></tr>";
	print "<tr><td colspan=2><font color=gray><input type=checkbox id=captcha name=UseCaptcha ".($Array->UseCaptcha?"checked":"")." value=1> <label for=captcha>".CONTROL_CLASS_USE_CAPTCHA."</label></td></tr>";
 	print "<tr><td colspan=2><font color=gray>".CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_SYSTEM.":<br><TEXTAREA WRAP=OFF ROWS=8 COLS=60 NAME=Settings>".htmlspecialchars($Array->Settings)."</TEXTAREA></td></tr>";
 	print "<tr><td colspan=2><INPUT TYPE=hidden NAME=DaysToHold SIZE=4 VALUE='".htmlspecialchars($Array->DaysToHold)."'></td></tr>";
 	print "<tr><td colspan=2><font color=gray><a href='ExportToFile.php?ClassID=".$ClassID."'>".CONTROL_CLASS_EXPORT."</a></td></tr>";
	?>
	</table>
	<br>

	<div align=right>
	<?
	if($type==1 || $BaseClassID)
	{
		?>
		<input class=s type=submit value='<?=CONTROL_CLASS_ADD?>'>
		<?
	}
	elseif ($type>1)
	{
		?>
		<input class=s type=reset value="<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_CANCEL?>"> <input class=s type=submit value="<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE?>">
		<?
	}
	?>
	</div>
	<?
	if($BaseClassID)
		print "<INPUT TYPE=HIDDEN NAME=BaseClassID VALUE=".$BaseClassID.">\n";
	else
		print "<INPUT TYPE=HIDDEN NAME=ClassID VALUE=".$ClassID.">\n";
 	?>

	<input type=hidden name=ClassGroup value='<?=$ClassGroup?>'>
	<input type=hidden name=phase value=<?=$phase?>>
	<input type=hidden name=type value=<?
	if($BaseClassID) $type=1;
	print $type;
	?>>
	</form>
	<?
}


##############################################
# / 
##############################################
function ActionClassComleted ($type)
{
	global $db, $ROOT_FOLDER;
	global $perm;

	while (list($key, $val) = each($_POST)) eval("global \$".$key.";");

	$AllowTags += 0;
	$NL2BR += 0;
	$DaysToHold += 0;
	$RecordsPerPage += 0;
	$UseCaptcha = (int)$UseCaptcha;

	if ($type == 1)
	{
    	$insert = "INSERT INTO Class (Class_Name,Class_Group,DaysToHold,AllowTags,NL2BR,FormPrefix,FormSuffix,RecordTemplate,RecordTemplateFull,RecordsPerPage,SortBy,TitleTemplate,Settings,UseCaptcha) ";
    	$insert .= "VALUES (";
    	$insert .= "\"".$ClassName."\",";
    	if ($Class_Group_New)
    		$insert .= "\"".$Class_Group_New."\",";
		elseif ($Class_Group)
			$insert .= "\"".$Class_Group."\",";
	    $insert .= "\"".$DaysToHold."\",";
    	$insert .= $AllowTags.",";
    	$insert .= $NL2BR.",";
    	$insert .= "\"".$FormPrefix."\",";
    	$insert .= "\"".$FormSuffix."\",";
    	$insert .= "\"".$RecordTemplate."\",";
    	$insert .= "\"".$RecordTemplateFull."\",";
    	$insert .= "\"".$RecordsPerPage."\",";
    	$insert .= "\"".$SortBy."\",";
    	$insert .= "\"".$TitleTemplate."\",";
    	$insert .= "\"".$Settings."\",";
    	$insert .= "'$UseCaptcha'";
    	$insert .= ")";

    	$db->query($insert);
    	$CurrentClassID = $db->insert_id;
	    CreateMessageTable ($CurrentClassID, $db);
		$Ret=$CurrentClassID;
 	}


	if ( ($type == 2) or ($type == 3) )
	{
    	$update = "UPDATE Class SET ";
    	if ($type == 2)
    		$update .= "Class_Name=\"".$ClassName."\",";

    	if ($Class_Group_New and $type==2)
    		$update .= "Class_Group=\"".$Class_Group_New."\",";
		elseif ($type==2)
			$update .= "Class_Group=\"".$Class_Group."\",";

    	$update .= "DaysToHold=\"".$DaysToHold."\",";
    	$update .= "AllowTags=\"".$AllowTags."\",";
    	$update .= "NL2BR=\"".$NL2BR."\",";
    	$update .= "FormPrefix=\"".$FormPrefix."\",";
    	$update .= "FormSuffix=\"".$FormSuffix."\",";
    	$update .= "RecordTemplate=\"".$RecordTemplate."\",";
    	$update .= "RecordTemplateFull=\"".$RecordTemplateFull."\",";
    	$update .= "RecordsPerPage=\"".$RecordsPerPage."\",";
    	$update .= "SortBy=\"".$SortBy."\",";
    	$update .= "TitleTemplate=\"".$TitleTemplate."\",";
    	$update .= "Settings=\"".$Settings."\",";
    	$update .= "UseCaptcha=\"".$UseCaptcha."\"";

    	if ($type == 2)
    		$update .= " WHERE Class_ID=".$ClassID;
    	if ($type == 3)
    		$update .= " WHERE System_Table_ID=".$ClassID;
    	$Ret=$ClassID;
    	$db->query($update);
	}

	return $Ret;
}


##############################################
#      
##############################################
function addNewTemplate()
{
	global $db;

	if ( $Arrays = $db->get_results("SELECT Class_ID, Class_Name FROM Class WHERE System_Table_ID=0 ORDER BY Class_ID") )
	{
		foreach ( $Arrays as $Array )
		{
			$opt=$opt."<option value=".$Array->Class_ID.">".$Array->Class_Name."</option>\n";
		}
	}

	?>
	<form method=get>
	<font color=gray><?=CONTROL_CLASS_CLASS_CREATENEW_BASICOLD?>:<br>
	<table border=0 cellpadding=0 cellspacing=0><tr><td width=80%><select name=BaseClassID><? print $opt; ?></select></td><td>&nbsp;<input type=submit value='<?=CONTROL_CLASS_CONTINUE?>'></td></tr></table>
	<input type=hidden name=phase value=2>
	</form>
	<b><a href=/netcat/admin/class/index.php?phase=2><?=CONTROL_CLASS_CLASS_CREATENEW_CLEARNEW?></a></b>
	<?
}


##############################################
#  
##############################################
function ConfirmDeletion ()
{
	global $db;
	$ask = false;

	reset($_POST);
	print "<form method=post action=index.php><ul>";
	while (list($key, $val) = each($_POST))
	{
		if (substr($key,0,6)=="Delete" && $val)
		{
			$ask = true;

			$class_id = substr($key,6,strlen($key)-6)+0;

			$SelectArray = $db->get_var("select Class_Name from Class where Class_ID=".$class_id) ;
			print "<li>".$SelectArray."<br>";
			print "<INPUT TYPE=HIDDEN NAME=".$key." VALUE=".$val.">";
			$class_counter++;
		}
	}

	if (!$ask) return false;

	if ($class_counter>1)
	{
		$post_f1 = CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_WARNING_SITEDELETE_I;
		$post_f2 = CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_WARNING_SITEDELETE_U;
	}
	?>
	</ul>
	<? printf(CONTROL_CLASS_CLASS_DELETE_WARNING, $post_f1, $post_f2); ?><br><br>
	<input type=hidden name=phase value=7>
	<table border=0 cellpadding=2 cellspacing=0><tr><td><INPUT TYPE=SUBMIT VALUE="<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_CONFIRMDELETE?>" class=s></td></form><?/*?><td><input type=button value='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_CANCEL?>' onclick=javascript:history.go(-1) class=s></td><?*/?></tr></table>
	<?
	return true;
}


##############################################
#  
##############################################
function CascadeDeleteClass ($ClassID)
{
	global $db;

	$LockTables = "LOCK TABLES Class WRITE, Field WRITE,";
	$LockTables .= "Message".$ClassID." WRITE,";
	$LockTables .= "Sub_Class WRITE";

	$LockResult = $db->query($LockTables.$AddLockTables);

	$DeleteClass = "DELETE FROM Class WHERE Class_ID=".$ClassID;
	$DeleteField = "DELETE FROM Field WHERE Class_ID=".$ClassID;
	$DeleteSubClass = "DELETE FROM Sub_Class WHERE Class_ID=".$ClassID;
	$DropMessage = "DROP TABLE Message".$ClassID;

	$db->query($DropMessage);
	$db->query($DeleteSubClass);
	$db->query($DeleteField);
	$db->query($DeleteClass);

	$UnlockResult = $db->query("UNLOCK TABLES");
}

##############################################
#   
##############################################
function ClassActionForm ($ClassID, $action, $phase, $type, $myaction)
{
	global $db,$ClassGroup;

	# type=1 -  
	# type=2 -   
	#  type=2 ClassID -     SystemTableID

	if (!$ClassID) {
		print "<BR>".CONTROL_CLASS_ERRORS_DB."<BR>\n";
		return;
	}

	?>
	<form method=post action="<?= $action ?>">
	<font color=gray>
	<?

	$select = "SELECT AddTemplate, AddCond, AddActionTemplate, EditTemplate, EditCond, EditActionTemplate, CheckActionTemplate, DeleteActionTemplate, ";
	$select .= "SearchTemplate, FullSearchTemplate, SubscribeTemplate, SubscribeCond";

	if ($type == 1)
		$select .= " FROM Class WHERE Class_ID=";
	if ($type == 2)
		$select .= " FROM Class WHERE System_Table_ID=";
	$select .= $ClassID;

	if (!$Array = $db->get_row($select))
		print "<BR>".CONTROL_CLASS_ERRORS_DB."<BR>\n";

 	switch ($myaction) {
        case 1: {

                print CONTROL_CLASS_CLASS_FORMS_ADDFORM.":<br><TEXTAREA ROWS=10 WRAP=OFF COLS=60 NAME=AddTemplate>".htmlspecialchars($Array->AddTemplate)."</TEXTAREA><br><br>";
                print CONTROL_CLASS_CLASS_FORMS_ADDRULES.":<br><TEXTAREA ROWS=10 WRAP=OFF COLS=60 NAME=AddCond>".htmlspecialchars($Array->AddCond)."</TEXTAREA><br><br>";
                print CONTROL_CLASS_CLASS_FORMS_ADDLASTACTION.":<br><TEXTAREA ROWS=10 WRAP=OFF COLS=60 NAME=AddActionTemplate>".htmlspecialchars($Array->AddActionTemplate)."</TEXTAREA><br><br>";

                }  break;
        case 2: {

                print CONTROL_CLASS_CLASS_FORMS_EDITFORM.":<br><TEXTAREA ROWS=10 WRAP=OFF COLS=60 NAME=EditTemplate>".htmlspecialchars($Array->EditTemplate)."</TEXTAREA><br><br>";
                print CONTROL_CLASS_CLASS_FORMS_EDITRULES.":<br><TEXTAREA ROWS=10 WRAP=OFF COLS=60 NAME=EditCond>".htmlspecialchars($Array->EditCond)."</TEXTAREA><br><br>";
                print CONTROL_CLASS_CLASS_FORMS_EDITLASTACTION.":<br><TEXTAREA ROWS=10 WRAP=OFF COLS=60 NAME=EditActionTemplate>".htmlspecialchars($Array->EditActionTemplate)."</TEXTAREA><br><br>";
                print CONTROL_CLASS_CLASS_FORMS_ONONACTION.":<br><TEXTAREA ROWS=10 WRAP=OFF COLS=60 NAME=CheckActionTemplate>".htmlspecialchars($Array->CheckActionTemplate)."</TEXTAREA><br><br>";
                print CONTROL_CLASS_CLASS_FORMS_ONDELACTION.":<br><TEXTAREA ROWS=10 WRAP=OFF COLS=60 NAME=DeleteActionTemplate>".htmlspecialchars($Array->DeleteActionTemplate)."</TEXTAREA><br><br>";

                } break;
        case 3: {

                print CONTROL_CLASS_CLASS_FORMS_QSEARCH.":<br><TEXTAREA ROWS=10 WRAP=OFF COLS=60 NAME=FullSearchTemplate>".htmlspecialchars($Array->FullSearchTemplate)."</TEXTAREA><br><br>";
                print CONTROL_CLASS_CLASS_FORMS_SEARCH.":<br><TEXTAREA ROWS=10 WRAP=OFF COLS=60 NAME=SearchTemplate>".htmlspecialchars($Array->SearchTemplate)."</TEXTAREA><br><br>";

                } break;
        case 4: {

                print CONTROL_CLASS_CLASS_FORMS_MAILRULES.":<br><TEXTAREA ROWS=10 WRAP=OFF COLS=60 NAME=SubscribeCond>".htmlspecialchars($Array->SubscribeCond)."</TEXTAREA><br><br>";
                print CONTROL_CLASS_CLASS_FORMS_MAILTEXT.":<br><TEXTAREA ROWS=10 WRAP=OFF COLS=60 NAME=SubscribeTemplate>".htmlspecialchars($Array->SubscribeTemplate)."</TEXTAREA><br><br>";

                } break;
	}


	?>
	<hr size=1 color=cccccc>
	<div align=right><input type=reset class=s value='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_CANCEL?>'> <input type=submit value="<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE?>" class=s></div>
	<?
 	print "<INPUT TYPE=HIDDEN NAME=ClassID VALUE=".$ClassID.">\n";
 	print "<input type=hidden name=phase value=".$phase.">";
 	print "<input type=hidden name=myaction value=".$myaction.">";
 	print "<input type=hidden name=type value=".$type.">";
	print "<input type=hidden name=ClassGroup value='".$ClassGroup."'>";
 	?>
  	</form>
 	<?
}

##############################################
#    
##############################################
function ClassActionCompleted ($myaction,$type)
{
	global $db;
	# type=1 -  
	# type=2 -   
	#  type=2 ClassID -     SystemTableID

	while (list($key, $val) = each($_POST))
		eval("global \$".$key.";");

	$update = "UPDATE Class SET ";
	 switch ($myaction) {

        case 1: {
                $update .= "AddTemplate=\"".$AddTemplate."\",";
                $update .= "AddCond=\"".$AddCond."\",";
                $update .= "AddActionTemplate=\"".$AddActionTemplate."\"";
        } break;

        case 2: {
                $update .= "EditTemplate=\"".$EditTemplate."\",";
                $update .= "EditCond=\"".$EditCond."\",";
                $update .= "EditActionTemplate=\"".$EditActionTemplate."\",";
                $update .= "CheckActionTemplate=\"".$CheckActionTemplate."\",";
                $update .= "DeleteActionTemplate=\"".$DeleteActionTemplate."\"";
        } break;

        case 3: {
                $update .= "FullSearchTemplate=\"".$FullSearchTemplate."\",";
                $update .= "SearchTemplate=\"".$SearchTemplate."\"";
        } break;

        case 4: {
                $update .= "SubscribeCond=\"".$SubscribeCond."\",";
                $update .= "SubscribeTemplate=\"".$SubscribeTemplate."\"";
        } break;
	}

	if ($type == 1)
		$update .= " WHERE Class_ID=".$ClassID;
	if ($type == 2)
		$update .= " WHERE System_Table_ID=".$ClassID;

 	$db->query($update);
}

?>
