<?
require_once ("../../vars.inc.php");
require ("../function.inc.php");
require ("function.inc.php");
require ("../tar.inc.php");

global $db;

$Delimeter = " &gt ";
$main_section = "settings";
$item_id=4;
$Title2 = TOOLS_PATCH;
$Title3 = "<a href=/netcat/admin/patch/>".TOOLS_PATCH."</a>";
$Title4 = TOOLS_PATCH_CHEKING;

if ( !($perm->isSupervisor() || $perm->isGuest()) )
{
    BeginHtml ($Title2, $Title2, "");
    print $NO_RIGHTS_MESSAGE;
    EndHtml ();
    exit;
}

if ( $perm->isGuest() && $phase > 1 )
{
    BeginHtml ($Title2, $Title2, "");
    print $NO_RIGHTS_MESSAGE;
    EndHtml ();
    exit;
}


if (!isset($phase))
{
    $phase=1;
}

switch ($phase)
{
	#   
    case 1:
        BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/settings/patch/");

        if ($PLUGS_INSTALL_TYPE=="int")
        {
            PatchForm ();
        }
        else
        {
            echo TOOLS_PATCH_INSTALEXT."<br><br>";
        }
        PatchList ();
        break;

	#   
    case 2:
        BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/settings/patch/");
        $perm->ExitIfGuest ();
		$err=0;

		if (!checkPermissions("/netcat/",$DOCUMENT_ROOT))
			break;
		if (!checkPermissions("/netcat/tmp/",$DOCUMENT_ROOT))
			break;

        if (!$_FILES['FilePatch']['tmp_name'])
        {
            print TOOLS_MODULES_ERR_NOTUPLOADED."."."<br>\n";
            InstallationAborted ();
        }

        $PatchFile = tempnam($TMP_FOLDER, "patch");
        move_uploaded_file($_FILES['FilePatch']['tmp_name'], $PatchFile);
        // this temporary file will be deleted in the end of this function or in InstallationAborted()

        if (!nc_tgz_extract($PatchFile, $TMP_FOLDER) && !file_exists($TMP_FOLDER."id.txt"))
        {
           print TOOLS_PATCH_ERR_EXTRACT;
           InstallationAborted();
        }


        if (!CheckDeps () )
        {
            InstallationAborted ();
        }

        if ($VersionID != $VERSION_ID)
        {
            print TOOLS_PATCH_INVALIDVERSION." NetCat.<br>\n";
            InstallationAborted ();
        }

        if ($SystemID != $SYSTEM_ID)
        {
            print TOOLS_PATCH_INVALIDVERSION." NetCat.<br>\n";
            InstallationAborted ();
        }

        if ( IsAlreadyInstalled () )
        {
            print TOOLS_PATCH_ALREDYINSTALLED.".<br>\n";
            InstallationAborted ();
        }

        $InstallFile = $TMP_FOLDER."install.inc.php";
        if (!is_readable ($InstallFile) )
        {
            print TOOLS_MODULES_ERR_CANTOPEN." install.inc.php.<br>\n";
            InstallationAborted ();
        }
        else
        {
            require $InstallFile;
        }

        if (!is_readable ($TMP_FOLDER."id.txt") )
        {
            print TOOLS_MODULES_ERR_CANTOPEN." id.txt.<br>\n";
            InstallationAborted ();
        }

        if (!is_readable ($TMP_FOLDER."files.txt") )
        {
            print TOOLS_MODULES_ERR_CANTOPEN." files.txt.<br>\n";
            InstallationAborted ();
        }

        if (!is_readable ($TMP_FOLDER."sql.txt") )
        {
            print TOOLS_MODULES_ERR_CANTOPEN." sql.txt.<br>\n";
            InstallationAborted ();
        }

        if (!is_readable ($TMP_FOLDER."required.txt") ) {
            print TOOLS_MODULES_ERR_CANTOPEN." required.txt.<br>\n";
            InstallationAborted ();
        }

        if (!is_readable ($TMP_FOLDER."symlinks.txt") )
        {
            print TOOLS_MODULES_ERR_CANTOPEN." symlinks.txt.<br>\n";
            InstallationAborted ();
        }


        $Ability = CheckAbilityOfInstallation ();
        if ($Ability["Success"] == 0)
        {
            print TOOLS_PATCH_ERROR.": ".$Ability["ErrorMessage"].".<br>\n";
            InstallationAborted ();
        }

        $Install = InstallPatch ();
        if ($Install["Success"] == 0)
        {
            print TOOLS_PATCH_ERROR_DURINGINSTALL.": ".$Install["ErrorMessage"].".<br>\n";
            InstallationAborted ();
        }

        CopyFiles ();
        ExecSQL ($TMP_FOLDER."sql.txt");
        CreatLinks ();

        $inserted = $db->query("INSERT INTO Patch (Patch_Name,Created,Description) VALUES ('$PatchName','".date('Ymd')."','$Description')");

        DeleteFilesInDirectory ($TMP_FOLDER);
        print TOOLS_PATCH_INSTALLED.".";

        break;
    case 3:
        BeginHtml ($Title4, $Title3.$Delimeter.$Title4, "http://".$DOC_DOMAIN."/settings/patch/");

        CheckForNewPatch();

        break;

}


EndHtml ();

?>
