<?php

/* $Id: function.inc.php,v 1.3 2006/10/24 09:21:48 kx Exp $ */

function nc_captcha_generate_hash() {

   $captcha_hash = md5(uniqid(rand(), true));
   return $captcha_hash;

}


function nc_captcha_generate_code($captcha_hash) {

   global $db;
   global $MODULE_VARS;

   //     

   $alphabet   = ( $MODULE_VARS['captcha']['ALPHABET'] ? $MODULE_VARS['captcha']['ALPHABET'] : 'ABCDEFGHKLMNOPRSTUVWXYZ');
   $num_chars  = ( $MODULE_VARS['captcha']['NUMBER_OF_CHARS'] ? $MODULE_VARS['captcha']['NUMBER_OF_CHARS'] : 5);

   if (strpos($num_chars, ".."))
   {
      $num_chars = preg_split("|\.+|", $num_chars);
      $num_chars = rand($num_chars[0], $num_chars[1]);
   }

   //    
   $alphabet_size = strlen($alphabet);
   $captcha_code = '';
   for ($i = 0; $i < $num_chars; $i++) {
      $captcha_code .= $alphabet[rand(0, $alphabet_size - 1)];
   }

   //   
   $db->query("REPLACE INTO Captchas (Captcha_Hash, Captcha_Code) VALUES ('$captcha_hash', '$captcha_code')");

   return $captcha_code;
}


function nc_captcha_verify_code($user_code, $user_hash = '') {

   global $db;
   global $MODULE_VARS;

   if (!$user_code) {
      return false;
   }

   $hidden_field_name = ( $MODULE_VARS['captcha']['HIDDEN_FIELD_NAME'] ? $MODULE_VARS['captcha']['HIDDEN_FIELD_NAME'] : 'nc_captcha_hash' );

   //    ,     GET  POST 
   if (!$user_hash) {
      if (!empty($_GET[$hidden_field_name])) {
         $user_hash = $_GET[$hidden_field_name];
      }
      if (!empty($_POST[$hidden_field_name])) {
         $user_hash = $_POST[$hidden_field_name];
      }
   }

   $captcha_duration = ( $MODULE_VARS['DURATION'] ? $MODULE_VARS['DURATION'] : 5 * 60 );

   $captchas_count = (int) $db->get_var("SELECT COUNT(*) FROM Captchas WHERE UPPER(Captcha_Code) = UPPER('$user_code') AND Captcha_Hash = '".$user_hash."' AND NOW() - Captcha_Created <= ".$captcha_duration);

   if ($captchas_count == 1) {
      $captcha_valid =  true;
   }
   else {
      $captcha_valid = false;
   }

   $db->query("DELETE FROM Captchas WHERE Captcha_Hash = '$user_hash' OR NOW() - Captcha_Created >= ".$captcha_duration);

   return $captcha_valid;
}




function nc_captcha_formfield($attributes = '') {

   global $MODULE_VARS;

   $hidden_field_name = ( $MODULE_VARS['captcha']['HIDDEN_FIELD_NAME'] ? $MODULE_VARS['captcha']['HIDDEN_FIELD_NAME'] : 'nc_captcha_hash');

   $captcha_hash = nc_captcha_generate_hash();

   return "<input type='hidden' name='".$hidden_field_name."' value='".$captcha_hash."'><img src='/netcat/modules/captcha/img.php?code=".$captcha_hash."'".($attributes ? " ".$attributes : "").">";
}



function nc_captcha_image($captcha_hash) {

   global $MODULE_VARS;

   $captcha_code = nc_captcha_generate_code($captcha_hash);

   //        ,
   //   
   include_once("$GLOBALS[MODULE_FOLDER]captcha/user_functions.inc.php");
   if (function_exists('nc_captcha_user_image')) { return nc_captcha_user_image($captcha_code); }

   // "" 
   //       GD   GIF
   if (!function_exists("imagegif")) {
      return false;
   }

   $num_chars = strlen($captcha_code);

   //     

   $img_width  = ( $MODULE_VARS['captcha']['IMAGE_WIDTH'] ? $MODULE_VARS['captcha']['IMAGE_WIDTH'] : 150);
   $img_height = ( $MODULE_VARS['captcha']['IMAGE_HEIGHT'] ? $MODULE_VARS['captcha']['IMAGE_HEIGHT'] : 30);
   $num_lines  = ( isset($MODULE_VARS['captcha']['NUMBER_OF_LINES']) ? $MODULE_VARS['captcha']['NUMBER_OF_LINES'] : 30);

   $letter_width = (int) ($img_width / $num_chars);
   $captcha_image = imagecreate($img_width, $img_height);

   //  
   imagecolorallocate($captcha_image, 255, 255, 255);

   //     
   for ($i = 0; $i < $num_lines; $i++) {
      $rand_color = rand(80, 150);

      $line_color = imagecolorallocate($captcha_image, $rand_color, $rand_color, $rand_color);
      imageline($captcha_image, rand(0, $img_width), rand(0, $img_height), rand(0, $img_width), rand(0, $img_height), $line_color);
   }

   //   
   for ($i = 0; $i < strlen($captcha_code); $i++) {
      $rand_color = rand(0, 100);
      $text_color = imagecolorallocate($captcha_image, $rand_color, $rand_color, $rand_color);
      $rand_font = rand(2, 5);

      $rand_x = rand(0, $letter_width - imagefontwidth($rand_font));
      $rand_y = rand(0, $img_height - imagefontheight($rand_font));

      imagestring($captcha_image, $rand_font, $i * $letter_width + $rand_x, $rand_y, $captcha_code[$i], $text_color);
   }

   return imagegif($captcha_image);

}


?>