<?

$GLOBALS["PRINT_QUERIES"] = 0;
$GLOBALS["ENABLE_BENCHMARK"] = 0;

if (!function_exists("int")) //  can be included several times despite require_once!
{
   /**
     * Cast to integer or double
     */
   function int(&$int)
   {
      if ($int > 2147483647) { $int = (double)$int; }
                        else { $int = (int)$int; }

      return $int;
   }



   /**
    *   
    *
    * @param  string query
    * @return mixed query result
    * @global bool ENABLE_BENCHMARK
    * @global bool PRINT_QUERIES
    * @global integer LAST_INSERT_ID
    */
   function q($query, $ignore_errors = false)
   {
      global $LinkID;

      if ($GLOBALS["ENABLE_BENCHMARK"]) starttimer("SQLQ0");

      $res = mysql_query($query,$LinkID);
      if ($GLOBALS["PRINT_QUERIES"]) print "<![CDATA[<pre><font color=red>$query</font> [<font color=blue>".mysql_affected_rows()."</font>]</pre><hr>]]>";

      if (mysql_error())
      {
         //if (!$ignore_errors) { user_error(mysql_error()."\n<br><b>Query:</b> <pre>$query</pre>\n"); }
         print mysql_error()."\n<br><b>Query:</b> <pre>$query</pre>\n";
         return false;
      }
      else
      {

         if ($GLOBALS["ENABLE_BENCHMARK"])
         {
           $e = stoptimer("SQLQ0", "SQL", $query); // NOT LOGGED FOR QUERIES CAUSED ERROR
           if ($GLOBALS["PRINT_QUERIES"]) { print "<font color=green>$e</font>"; }
         }

         return $res;
      }
   }


   /**
    *  mysql_fetch_assoc(q($query))
    *
    * @param  string query
    * @return mixed   
    */
   function row($query)
   {
     return @mysql_fetch_assoc(q($query));
   }


   /**
    *   
    *
    * @param  string query
    * @return mixed  value
    */
   function value1($query)
   {
     return @mysql_result(q($query),0,0);
   }



   /**
     *      
     * @var integer   (ID )lib.php
     * @var string ,   
     * @return mixed  Subdivision.$what  
     */
   function GetSubdivisionByType($class_id, $what="*")
   {
     if (!int($class_id) || !int($GLOBALS["catalogue"])) return false;

     $qry = "FROM Subdivision as s, Sub_Class as c
             WHERE c.Class_ID = $class_id
               AND c.Subdivision_ID = s.Subdivision_ID
               AND s.Catalogue_ID = $GLOBALS[catalogue]
             LIMIT 1";

     return (strpos($what,",") || $what=="*"
              ? row("SELECT s.$what $qry")
              : value1("SELECT s.$what $qry"));
   }

   /**
     *     $type_id   $subdivision_id
     */
   function GetTemplateByType($type_id, $subdivision_id, $fields = "*")
   {
      return row("SELECT $fields
                  FROM Sub_Class as c, Subdivision as s
                  WHERE c.Class_ID = $type_id
                    AND c.Subdivision_ID = $subdivision_id
                    AND c.Subdivision_ID = s.Subdivision_ID
                  ORDER BY s.Priority
                  LIMIT 1");
   }

   /**
     *  ""  $section
     * @param integer subdivision_id
     * @param string WHERE
     * @param string (plain | get_children)
     * @return array
     */
   function GetStructure($section, $where=1, $mode="plain")
   {
      if (!int($section)) return false;
      if (!$where) $where = 1;

      global $_structure_level;

      $ret = array();

      $res = q("SELECT *
                FROM Subdivision
                WHERE $where AND Parent_Sub_ID = $section");

      while ($row=mysql_fetch_assoc($res))
      {
         $row["level"] = (int)$_structure_level;
         $ret[$row["Subdivision_ID"]] = $row;
         $_structure_level++;
         $children = GetStructure($row["Subdivision_ID"],$where);
         $_structure_level--;

         foreach ($children as $idx=>$row2)
         {
            $ret[$idx] = $row2;
         }
      }

      if ($mode=="get_children")
      {
         foreach ($ret as $idx=>$row)
         {
            while ($row["Parent_Sub_ID"] != $section)
            {
               $ret[$row["Parent_Sub_ID"]]["Children"][] = $row["Subdivision_ID"];
               $row = $ret[$row["Parent_Sub_ID"]];
            }
         }
      }

      return $ret;
   }


   // transliterate
   function tr($str)
   {
      $abc = array(
              ""=>"A",  ""=>"a",  ""=>"B",  ""=>"b",
              ""=>"V",  ""=>"v",  ""=>"G",  ""=>"g",
              ""=>"D",  ""=>"d",  ""=>"E",  ""=>"e",
              ""=>"E",  ""=>"e",  ""=>"Zh", ""=>"zh",
              ""=>"Z",  ""=>"z",  ""=>"I",  ""=>"i",
              ""=>"Y",  ""=>"y",  ""=>"K",  ""=>"k",
              ""=>"L",  ""=>"l",  ""=>"M",  ""=>"m",
              ""=>"N",  ""=>"n",  ""=>"O",  ""=>"o",
              ""=>"P",  ""=>"p",  ""=>"R",  ""=>"r",
              ""=>"S",  ""=>"s",  ""=>"T",  ""=>"t",
              ""=>"U",  ""=>"u",  ""=>"F",  ""=>"f",
              ""=>"H",  ""=>"h",  ""=>"Ts", ""=>"ts",
              ""=>"Ch", ""=>"ch", ""=>"Sh", ""=>"sh",
              ""=>"Sch",""=>"sch",""=>"Y",  ""=>"y",
              ""=>"",   ""=>"",   ""=>"E",  ""=>"e",
              ""=>"",   ""=>"",   ""=>"Yu", ""=>"yu",
              ""=>"Ya", ""=>"ya"
              );

       foreach ($abc as $r=>$l) { $str = str_replace($r, $l, $str); }
       return $str;
   }



   //  ngene  
   function timestamp($value)
   {
      // convert to timestamp:
      //              1=yr              2=mon    3=day        4=hr    5=min     6=sec
      if (preg_match("/^((?:19|20)\d{2})-?(\d{2})-?(\d{2})(?:\s?(\d{2}):?(\d{2}):?(\d{2}))?/",
                 $value, $regs))
      {  return mktime($regs[4], $regs[5], $regs[6], $regs[2], $regs[3], $regs[1]); }
      else { return $value; }
   }


    /**
      *  ngene  
      *
      *    key=>value (,   <options>  <select>)
      *      ,    q($query)
      *
      * @param string SQL-query
      * @return array Associative array ($col1=>$col2 OR $col1=>$row)
      */
    function assoc_array($query)
    {
       $res = q($query);
       if (!mysql_num_rows($res)) { return array(); }
       else
       {
          $arr = array();

          while ($row = mysql_fetch_assoc($res))
          {
             list ($col1, $col2) = array_keys($row);

             if (sizeof($row)==1)
             {
                $arr[] = $row[$col1];
             }
             elseif (sizeof($row)==2) //     
             {
                $arr[$row[$col1]] = $row[$col2];
             }
             else //  -   ($row)
             {
                $arr[$row[$col1]] = $row;
             }
          }
       }

       return $arr;

    }

    function xmlspecialchars($str)
    {
       $str = str_replace('&', "&amp;", $str);
       $str = str_replace('"', "&quot;", $str);
       $str = str_replace('>', "&gt;", $str);
       $str = str_replace('<', "&lt;", $str);
       $str = str_replace("'", "&apos;", $str);

       return $str;
    }

}


/**
 * Replace array_combine()
 *
 * @category    PHP
 * @package     PHP_Compat
 * @link        http://php.net/function.array_combine
 * @author      Aidan Lister <aidan@php.net>
 * @version     $Revision: 1.8 $
 * @since       PHP 5
 * @require     PHP 4.0.0 (user_error)
 */
if (!function_exists('array_combine')) {
    function array_combine($keys, $values)
    {
        if (!is_array($keys)) {
            user_error('array_combine() expects parameter 1 to be array, ' .
                gettype($keys) . ' given', E_USER_WARNING);
            return;
        }

        if (!is_array($values)) {
            user_error('array_combine() expects parameter 2 to be array, ' .
                gettype($values) . ' given', E_USER_WARNING);
            return;
        }

        $key_count = count($keys);
        $value_count = count($values);
        if ($key_count !== $value_count) {
            user_error('array_combine() Both parameters should have equal number of elements', E_USER_WARNING);
            return false;
        }

        if ($key_count === 0 || $value_count === 0) {
            user_error('array_combine() Both parameters should have number of elements at least 0', E_USER_WARNING);
            return false;
        }

        $keys    = array_values($keys);
        $values  = array_values($values);

        $combined = array();
        for ($i = 0; $i < $key_count; $i++) {
            $combined[$keys[$i]] = $values[$i];
        }

        return $combined;
    }
}






?>