<?
$main_section = "settings";
$item_id = 3;

require_once ("../../vars.inc.php");
require ("admin.inc.php");
require ("../../admin/function.inc.php");
require ($INCLUDE_FOLDER."s_loadenv.inc.php");

if (is_file($MODULE_FOLDER."stats/".MAIN_LANG.".lang.php"))
{
    require_once($MODULE_FOLDER."stats/".MAIN_LANG.".lang.php");
}
else
{
    require_once($MODULE_FOLDER."stats/en.lang.php");
}

$stats_cat_id = stats_IsOneCatalogue();

if ( $stats_cat_id != FALSE )
{
    $cat_id = $stats_cat_id;
    if ($phase == 0)
    {
        $phase = 9;
    }
}


$Delimeter = " &gt ";
$Title1 = NETCAT_MODULE_STATS;
$Title2 = "<a href=/netcat/admin/modules/>".NETCAT_MODULES."</a>";
$Title3 = "<a href='/netcat/modules/stats/admin.php'>".$Title1."</a>";
if (isset($cat_id) && $cat_id != 0)
$Title4 = $Title2.$Delimeter.$Title3.$Delimeter.GetCatalogueNameByID($cat_id);

if ( !($perm->isSupervisor() || $perm->isGuest()) ) {
    BeginHtml ($Title1, $Title2.$Delimeter.$Title1, "http://".$DOC_DOMAIN."/settings/modules/stats/");
    print $NO_RIGHTS_MESSAGE;
    EndHtml ();
    exit;
}

LoadModuleEnv();

$phase+=0;

//stats_CreateReports();

if (isset($cat_id) && $cat_id != 0)
{
    BeginHtml($Title1, $Title4, "http://".$DOC_DOMAIN."/settings/modules/stats/");
}
else
{
    BeginHtml($Title1, $Title2.$Delimeter.$Title1, "http://".$DOC_DOMAIN."/settings/modules/stats/");
}

if ($date_start_y && $date_start_m && $date_start_d) $date_start = sprintf("%04d-%02d-%02d", $date_start_y, $date_start_m, $date_start_d);
if ($date_end_y && $date_end_m && $date_end_d)       $date_end   = sprintf("%04d-%02d-%02d", $date_end_y,   $date_end_m,   $date_end_d);

if (!$date_start) $date_start = date("Y-m-d");
if (!$date_end) $date_end = date("Y-m-d");

list($date_start_y, $date_start_m, $date_start_d) = split("-", $date_start);
list($date_end_y,   $date_end_m,   $date_end_d)   = split("-", $date_end);


if ($phase != 0) { Stats_NavBar(); }


switch ($phase) {
    case 0:
      stats_ShowCatalogues();
      break;
    case 1:
      stats_ShowReportAttendance($date_start,$date_end);
      break;
    case 2:
      stats_ShowReportPopularity($date_start,$date_end);
      break;
    case 3:
      stats_ShowReportReferer($date_start,$date_end);
      break;
    case 4:
      stats_ShowReportBrowser($date_start,$date_end);
      break;
    case 5:
      stats_ShowReportOS($date_start,$date_end);
      break;
    case 6:
      stats_ShowReportIP($date_start,$date_end);
      break;
    case 7:
      stats_ShowReportGeo($date_start,$date_end);
      break;
    case 8:
      stats_ClearStats();
      stats_ShowReportTotal();
      break;
    case 9:
      stats_ShowReportTotal();
      break;
    case 10:
      stats_ShowReportPhrases($date_start, $date_end);
      break;
}


EndHtml ();

?>