<?php
/* $Id: auth.inc.php,v 1.8 2006/10/23 11:53:00 kx Exp $ */

@include_once("../vars.inc.php");
require ($ADMIN_FOLDER.'consts.inc.php');
require_once ($GLOBALS["ROOT_FOLDER"].'connect_io.php');


function GetCatalogueBySubdivision ($SubdivisionID)
{
    global $db;
    @$ResultArray = $db->get_var("select Catalogue_ID from Subdivision where Subdivision_ID='".$SubdivisionID."'");
    return $ResultArray;
}

function GetCatalogueNameByID ($CatalogueID)
{
    global $db;
    @$ResultArray = $db->get_var("select Catalogue_Name from Catalogue where Catalogue_ID='".$CatalogueID."'");
    return $ResultArray;
}

function GetSubdivisionNameByID ($SubdivisionID)
{
    global $db;
@$ResultArray = $db->get_var("select Subdivision_Name from Subdivision where Subdivision_ID='".$SubdivisionID."'");
    return $ResultArray;
}

function GetCatalogueNameBySubdivisionID ($SubdivisionID)
{
    global $db;

    $select = "select Catalogue_Name from Catalogue,Subdivision where Subdivision_ID='";
    $select .= $SubdivisionID."'";
    $select .= " and Subdivision.Catalogue_ID=Catalogue.Catalogue_ID";
    $ResultArray = $db->get_var($select);

    return $ResultArray;
}

function GetSubdivisionIDByMessageID ($MessageID, $ClassID)
{
    global $db;

    $select = "select Subdivision_ID from Message".$ClassID." where ";
    $select .= "Message_ID='".$MessageID."'";

    $ResultArray = $db->get_var($select);

    return $ResultArray;

}


function DeleteAllPermission ($UserID)
{
    global $db;

    $delete = "delete from Permission where User_ID='".$UserID."'";
    if ( $db->query ($delete) )
    return 1;
    else
    return 0;

}

function DeleteInSubscribe ($UserID)
{
    global $db;

    // is 'subscriber' module installed?
    if (!$db->get_var("SELECT count(*) FROM Module WHERE Keyword='subscriber'"))
           return 1;

    $delete = "delete from Subscriber where User_ID='".$UserID."'";
    if ($db->query ($delete) )
    return 1;
    else
    return 0;


}

function GetEmailByUserID ($UserID)
{
    global $db;

    $Select = "select Email from User where User_ID='";
    $Select .= $UserID."'";
    $ResultArray = $db->get_var($Select);
    return $ResultArray;
}

function SendEmail ($UserID, $Subject, $Message, $From)
{
    global $db;

    $Email = GetEmailByUserID ($UserID);
    mail ($Email, $Subject, $Message, "From: ".$From."\nX-Mailer: PHP/" . phpversion()."\nContent-Type: text/plain\nContent-Transfer-Encoding: 8bit\n" );
}

function SendEmailFromEmail ($Email, $Subject, $Message, $From)
{
    global $db;

    mail ($Email, $Subject, $Message, "From: ".$From."\nX-Mailer: PHP/" . phpversion()."\nContent-Type: text/plain\nContent-Transfer-Encoding: 8bit\nReturn-Path: <".$From.">");
}


class Permission {

    var $ARRAY, $COUNT;
    var $UserID;
    var $PermissionGroupID;

    function Permission ($UserID, $PermissionGroupID=0, $CountPermissionGroupID=1)
    {
        global $db;

        $this->UserID = $UserID;
        if ($PermissionGroupID == 0) {
            if ($CountPermissionGroupID == 1)
            $this->PermissionGroupID = GetPermissionGroupID ($UserID);
        } else {
            $this->PermissionGroupID = $PermissionGroupID;
        }

        $SelectPerm = "select Permission_ID,AdminType,Catalogue_ID,PermissionSet from Permission";
        $SelectPerm .= " where ";
        if ($this->UserID > 0) $SelectPerm .= " User_ID='".$UserID."'";
        if ($this->PermissionGroupID > 0) {
            if ($this->UserID > 0) $SelectPerm .= " or ";
            $SelectPerm .= " PermissionGroup_ID='".$this->PermissionGroupID."'";
        }

        for ($i=1; $i <= UserTypeCount; $i++) {
            $this->COUNT [$i] = 0;
        }

        if ($PermResult = $db->get_results($SelectPerm,ARRAY_N))
		{
			foreach ($PermResult as  $PermArray ) {
				$this->ARRAY [ $PermArray[1]  ][ $this->COUNT[$PermArray[1]] ][0] = $PermArray[2];
				$this->ARRAY [ $PermArray[1]  ][ $this->COUNT[$PermArray[1]] ][1] = $PermArray[0];
				$this->ARRAY [ $PermArray[1]  ][ $this->COUNT[$PermArray[1]] ][2] = $PermArray[3];
				$this->COUNT[$PermArray[1]]++;
			}
		}

    }


    function printPerm ()
    {
        for ($i=UserTypeCount; $i > 0; $i--) {
            for ($t=0; $t < $this->COUNT[$i]; $t++)

            if ( isset($this->ARRAY[$i][$t][0]) ) {
                print $this->ARRAY[$i][$t][0]."&nbsp;";
                print $this->ARRAY[$i][$t][1]."&nbsp;";
                print $this->ARRAY[$i][$t][2]."&nbsp;";
            }
            print "<br><br>\n";

        }

    }



    function getLogin ()
    {
        global $db;
        global $AUTHORIZE_BY;

        $select = "select $AUTHORIZE_BY from User where User_ID='".$this->UserID."'";
        $Array = $db->get_var ($select);

        return $Array;
    }

    function isDirector ()
    {
        if ( isset($this->ARRAY[DIRECTOR][0][0]) )
        return 1;
        else
        return 0;
    }

    function isGuest ()
    {
        global $PERM_ARRAY, $PERM_COUNT;
        if ( isset($this->ARRAY[GUEST][0]) && !$this->isSupervisor() )
        return 1;
        else
        return 0;
    }

    function isSupervisor ()
    {
        if ( $this->isDirector () ) return 1;
        if ( isset($this->ARRAY[SUPERVISOR][0][0]) )
        return 1;
        else
        return 0;
    }

    function isManager ()
    {
        if ( isset($this->ARRAY[MANAGER][0][0]) )
        return 1;
        else
        return 0;
    }

    function isCatalogueAdmin ($CatalogueID)
    {
        $ReturnValue = 0;

        for ($i=0; $i < MAX_CATALOGUE_NUMBER; $i++) {
            if ( !isset ($this->ARRAY[CATALOGUE_ADMIN][$i][0]) ) break;
            if ( ($this->ARRAY[CATALOGUE_ADMIN][$i][0] == $CatalogueID) && ($this->ARRAY[CATALOGUE_ADMIN][$i][2] & 32) ) {
                $ReturnValue = 1;
                break;
            }
        }

        return $ReturnValue;
    }

    function IsAnyCatalogueAdmin ()
    {
        if  ((isset($this->ARRAY[CATALOGUE_ADMIN][0][0])) && ($this->ARRAY[CATALOGUE_ADMIN][0][2] & 32) )
        return 1;
        else
        return 0;
    }

    function isSubdivisionAdmin ($SubdivisionID)
    {
        $ReturnValue = 0;
        for ($i=0; $i < MAX_SUBDIVISION_NUMBER; $i++) {
            if ( !isset ($this->ARRAY[SUBDIVISION_ADMIN][$i][0]) ) break;
            if ( ( $this->ARRAY[SUBDIVISION_ADMIN][$i][0] == $SubdivisionID ) && ($this->ARRAY[SUBDIVISION_ADMIN][$i][2] & 32) ) {
                $ReturnValue = 1;
                break;
            }
        }

        return $ReturnValue;
    }

    function IsAnySubdivisionAdmin ()
    {
        if ( (isset($this->ARRAY[SUBDIVISION_ADMIN][0][0]) ) && ($this->ARRAY[SUBDIVISION_ADMIN][0][2] & 31) )
        return 1;

        if ( (isset($this->ARRAY[SUBDIVISION_ADMIN][0][0]) ) && ($this->ARRAY[SUBDIVISION_ADMIN][0][2] & 32) )
        return 1;
        else
        return 0;
    }


    function isCatalogue ($CatalogueID, $mask)
    {
        $ReturnValue = 0;

        for ($i=0; $i < MAX_CATALOGUE_NUMBER; $i++) {
            if ( !isset ($this->ARRAY[CATALOGUE_ADMIN][$i][0]) ) break;
            if ( ($this->ARRAY[CATALOGUE_ADMIN][$i][0] == $CatalogueID) && ($this->ARRAY[CATALOGUE_ADMIN][$i][2] & $mask) ) {
                $ReturnValue = 1;
                break;
            }
        }

        return $ReturnValue;
    }

    function isSubdivision ($SubdivisionID, $mask)
    {
        $ReturnValue = 0;
        for ($i=0; $i < MAX_SUBDIVISION_NUMBER; $i++) {
            if ( !isset ($this->ARRAY[SUBDIVISION_ADMIN][$i][0]) ) break;
            if ( ( $this->ARRAY[SUBDIVISION_ADMIN][$i][0] == $SubdivisionID ) && ($this->ARRAY[SUBDIVISION_ADMIN][$i][2] & $mask) ) {
                $ReturnValue = 1;
                break;
            }
        }

        return $ReturnValue;
    }



    function isSubClassAdmin ($SubClassID)
    {
        $ReturnValue = 0;
        for ($i=0; $i < MAX_SUBDIVISION_NUMBER; $i++) {
            if ( !isset ($this->ARRAY[SUB_CLASS_ADMIN][$i][0]) ) break;
            if ( ( $this->ARRAY[SUB_CLASS_ADMIN][$i][0] == $SubClassID ) && ($this->ARRAY[SUB_CLASS_ADMIN][$i][2] & 32) ) {
                $ReturnValue = 1;
                break;
            }
        }

        return $ReturnValue;
    }

    function isAnySubClassAdmin ()
    {
        if ( (isset($this->ARRAY[SUB_CLASS_ADMIN][0][0]) ) && ($this->ARRAY[SUB_CLASS_ADMIN][0][2] & 31) )
        return 1;
        else
        return 0;
    }


    function isSubClass ($SubClassID, $mask)
    {
        $ReturnValue = 0;
        for ($i=0; $i < MAX_SUBDIVISION_NUMBER; $i++) {
            if ( !isset ($this->ARRAY[SUB_CLASS_ADMIN][$i][0]) ) break;
            if ( ( $this->ARRAY[SUB_CLASS_ADMIN][$i][0] == $SubClassID ) && ($this->ARRAY[SUB_CLASS_ADMIN][$i][2] & $mask) ) {
                $ReturnValue = 1;
                break;
            }
        }
        return $ReturnValue;
    }


    function ExitIfGuest ()
    { global $NO_RIGHTS_MESSAGE;
    if ( $this->isGuest() ) {
        print $NO_RIGHTS_MESSAGE;
        EndHtml ();
        exit;
    }

    }

    function ExitIfNotSupervisor ()
    { global $NO_RIGHTS_MESSAGE;
    if ( !$this->isSupervisor() ) {
        print $NO_RIGHTS_MESSAGE;
        EndHtml ();
        exit;
    }

    }


    function ExitIfNotSupervisorManager ()
    { global $NO_RIGHTS_MESSAGE;
    if ( !($this->isSupervisor() || $this->isManager()) ) {
        print $NO_RIGHTS_MESSAGE;
        EndHtml ();
        exit;
    }
    }

    function ExitIfNotSupervisorGuest ()
    { global $NO_RIGHTS_MESSAGE;
    if ( ! ($this->isSupervisor() || $this->isGuest() )  ) {
        print $NO_RIGHTS_MESSAGE;
        EndHtml ();
        exit;
    }

    }


    function ExitIfNotSupervisorManagerCatalogueAdmin ($CatalogueID)
    { global $NO_RIGHTS_MESSAGE;
    if ( !($this->isSupervisor() || $this->isManager() || $this->isCatalogueAdmin($CatalogueID) ) ) {
        print $NO_RIGHTS_MESSAGE;
        EndHtml ();
        exit;
    }
    }

    function ExitIfNotSupervisorManagerCatalogueSubdivisionAdmin ($CatalogueID, $SubdivisionID)
    { global $NO_RIGHTS_MESSAGE;
    if ( !($this->isSupervisor() || $this->isManager() || $this->isCatalogueAdmin($CatalogueID) || $this->isSubdivisionAdmin($SubdivisionID)  ) ) {
        print $NO_RIGHTS_MESSAGE;
        EndHtml ();
        exit;
    }
    }



}

?>